const log = require('./libs/log');
const pornhubScrapy = require('./pornhub/scrapy');
const xvideosScrapy = require('./xvideos/scrapy');

const parseArgs = () => {
    let config = {
        "downloadDir": "./downloads"
    };
    for (let arg of process.argv) {
        if (arg.indexOf("-") < 0) continue;
        let argKV = arg.split("=");
        if (argKV.length < 2) continue;
        switch (argKV[0]) {
            case "--target":
            case "-t":
                config["target"] = argKV[1].trim().toLowerCase();
                break;
            case "--url":
            case "-l":
                config["key"] = argKV[2].trim().toLowerCase();
                break;
            case "--search":
            case "-s":
                config["search"] = argKV[1].trim().toLowerCase();
                break;
            case "--tag":
            case "-g":
                config["tag"] = argKV[1].trim().toLowerCase();
                break;
            case "--category":
            case "-c":
                config["category"] = argKV[1].trim().toLowerCase();
                break;
            case "--proxy":
            case "-p":
                config["proxy"] = argKV[1].trim().toLowerCase();
                break;
            case "--dir":
            case "-d":
                config["downloadDir"] = argKV[1].trim().toLowerCase();
                break;
        }
    }
    return config;
};

const configIsLegal = (config) => {
    if (config.target === undefined) return false;
    if (config.target === "pornhub" && config.tag !== undefined) {
        log.info("Your target value is 'pornhub', so your 'tag' value will be ignored.");
    }
    if (config.target === "xvideos" && config.category !== undefined) {
        log.info("Your target value is 'xvideos', so your 'category' value will be ignored.");
    }
    if (config.proxy !== undefined) {
        log.info("The downloader will use your proxy : " + config.proxy);
    }
    log.info(`and the videos will be downloaded into your '${config.downloadDir}' folder.`)
    return true;
}


const run = async() => {
    const config = parseArgs();
    if (configIsLegal(config)) {
        switch (config.target) {
            case "pornhub":
                pornhubScrapy.start(config);
                break;
            case "xvideos":
                xvideosScrapy.start(config);
                break;
        }
    } else {
        log.error("ERROR: Arguments is illegal. Check it out.");
        log.warn("	--target,-t: Target website which you want to download videos. Value supports: 'pornhub/xvideos'");
        log.warn("	--url,-l: Target video page you want to download video. 'Pornhub/Xvideos' support only.");
        log.warn("	--search,-s: The key word you want to search and download.");
        log.warn("	--tag,-g: Download videos with the tag . 'Xvideos' support only.");
        log.warn("	--category,-c: Download videos under the categorie. 'Pornhub' support only.");
        log.info("	Optional: --proxy,-p: If you need proxy support (like Shadowsocks), set proxy url (such as -p=http://http://127.0.0.1:1087).");
        log.info("	Optional: --dir,-d: The directory you want to save videos. Default directory is `./downloads`.");

        process.exit(0);
    }

}

run();